package com.wlsdm.samples;

import java.io.File;

import javax.management.StandardMBean;
import javax.swing.filechooser.FileSystemView;

public class DiskSpaceWatcher extends StandardMBean implements DiskSpaceWatcherMBean {

	public double FreeDiskSpace = new Double(100.00);
	public double UsedDiskSpace = new Double(0.00);
	
	
	protected DiskSpaceWatcher() {
		super(DiskSpaceWatcherMBean.class, false);
		
		Thread t = new Thread(new CollectData());
		t.start();
		
	}

	@Override
	public double getFreeDiskSpace() {
		return FreeDiskSpace;
	}

	@Override
	public void setFreeDiskSpace(double fds) {
		FreeDiskSpace = fds;
		
	}

	@Override
	public double getUsedDiskSpace() {
		return UsedDiskSpace;
	}

	@Override
	public void setUsedDiskSpace(double uds) {
		UsedDiskSpace = uds;
		
	}
	
	private class CollectData implements Runnable {

		@Override
		public void run() {

			while (true) {
				
				File f = FileSystemView.getFileSystemView().getHomeDirectory();
				
				double free = ((double)f.getUsableSpace() / f.getTotalSpace()) * 100.00d;
				
				setFreeDiskSpace(free);
				setUsedDiskSpace(100.00 - free);
				
				try {
					Thread.sleep(60 * 1000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}

			}

		}

	}

}
